############################################################################
#                                                                          #
#  Copyright (c) 2001, 2021 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
sub NXClusterTools::generateClusterGUID{package NXClusterTools;no warnings;(my (
@command)=());push (@command,$GLOBAL::COMMAND_NXKEYGEN);push (@command,
"\x2d\x75");(my (@options)=());push (@options,"\x73\x65\x74\x20\x65\x6e\x76",(((
"\x4c\x44\x5f\x4c\x49\x42\x52\x41\x52\x59\x5f\x50\x41\x54\x48\x3d".
$GLOBAL::NODE_ROOT).$GLOBAL::DIRECTORY_SLASH)."\x6c\x69\x62"));push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",("\x4e\x58\x5f\x53\x59\x53\x54\x45\x4d\x3d".
$GLOBAL::NODE_ROOT));(my $homeDir=NXPaths::getUserNXHomeDir ());push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",("\x48\x4f\x4d\x45\x3d".$homeDir));(my ($cmdErr,
$cmdOut,$exitValue)=main::nxRunCommand ((\@command),(\@options)));if ((
$exitValue!=(0x06a9+ 8145-0x267a))){Logger::warning (
"\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x6e\x65\x72\x61\x74\x65\x20\x67\x75\x69\x64\x20\x6b\x65\x79\x2e"
);return ((""));}chomp ($cmdOut);return ($cmdOut);}sub 
NXClusterTools::generateClusterKeys{package NXClusterTools;no warnings;(my (
@command)=());push (@command,$GLOBAL::COMMAND_NXKEYGEN);(my $priv=
NXPaths::getClusterRSAPrivateKey ());(my $pub=NXPaths::getClusterRSAPublicKey ()
);push (@command,"\x2d\x6b",$priv);push (@command,"\x2d\x70",$pub);push (
@command,"\x2d\x74","\x72\x73\x61");(my (@options)=());push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",(((
"\x4c\x44\x5f\x4c\x49\x42\x52\x41\x52\x59\x5f\x50\x41\x54\x48\x3d".
$GLOBAL::NODE_ROOT).$GLOBAL::DIRECTORY_SLASH)."\x6c\x69\x62"));push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",("\x4e\x58\x5f\x53\x59\x53\x54\x45\x4d\x3d".
$GLOBAL::NODE_ROOT));(my $homeDir=NXPaths::getUserNXHomeDir ());push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",("\x48\x4f\x4d\x45\x3d".$homeDir));(my ($cmd_err,
$cmd_out,$exit_value)=main::nxRunCommand ((\@command),(\@options)));
changeFileOwnershipToNxIfRoot ($priv);changeFileOwnershipToNxIfRoot ($pub);if ((
Common::NXFile::setPermissionsReadWriteForNX ($priv)==(-(0x03b4+ 3053-0x0fa0))))
{Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x74\x6f\x20"
.$priv)."\x2e"));}if ((
Common::NXFile::setPermissionReadWriteForOwnerReadOnlyForAll ($pub)==(-
(0x1340+ 1069-0x176c)))){Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x74\x6f\x20"
.$pub)."\x2e"));}}sub NXClusterTools::generateClusterHostCerts{package 
NXClusterTools;no warnings;(my (@command)=());push (@command,
$GLOBAL::COMMAND_NXKEYGEN);(my $priv=NXPaths::getClustetHostPrivateCert ());(my $pub
=NXPaths::getClusterHostPublicCert ());push (@command,"\x2d\x6b",$priv);push (
@command,"\x2d\x63",$pub);(my (@options)=());push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",(((
"\x4c\x44\x5f\x4c\x49\x42\x52\x41\x52\x59\x5f\x50\x41\x54\x48\x3d".
$GLOBAL::NODE_ROOT).$GLOBAL::DIRECTORY_SLASH)."\x6c\x69\x62"));push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",("\x4e\x58\x5f\x53\x59\x53\x54\x45\x4d\x3d".
$GLOBAL::NODE_ROOT));(my $homeDir=NXPaths::getUserNXHomeDir ());push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",("\x48\x4f\x4d\x45\x3d".$homeDir));(my ($cmd_err,
$cmd_out,$exit_value)=main::nxRunCommand ((\@command),(\@options)));
changeFileOwnershipToNxIfRoot ($priv);changeFileOwnershipToNxIfRoot ($pub);if ((
Common::NXFile::setPermissionsReadWriteForNX ($priv)==(-(0x04fa+ 5907-0x1c0c))))
{Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x74\x6f\x20"
.$priv)."\x2e"));}if ((
Common::NXFile::setPermissionReadWriteForOwnerReadOnlyForAll ($pub)==(-
(0x09b8+ 246-0x0aad)))){Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x74\x6f\x20"
.$pub)."\x2e"));}}sub NXClusterTools::__ipTakeover{package NXClusterTools;no 
warnings;($GLOBAL::ClusterOldLocal=NXCluster::getMyIP ());
NXCluster::setInterfaceAndMask ();(my $interface=$GLOBAL::ClusterInterface);(my $mask
=$GLOBAL::ClusterNetmask);(my (@command)=());sub BEGIN{require NXTools;do{
"\x4e\x58\x54\x6f\x6f\x6c\x73"->import};}push (@command,
NXTools::getUnixCommandPath ("\x69\x66\x63\x6f\x6e\x66\x69\x67"));push (@command
,$interface);push (@command,$GLOBAL::ClusterHost);push (@command,
"\x6e\x65\x74\x6d\x61\x73\x6b",$mask);(my (@options)=());(my ($cmdOut,$cmdErr,
$exitValue)=main::nxRunCommand ((\@command),(\@options)));Logger::debug (((((((
"\x63\x6d\x64\x4f\x75\x74\x20\x5b".$cmdOut).
"\x5d\x20\x63\x6d\x64\x45\x72\x72\x20\x5b").$cmdErr).
"\x5d\x20\x65\x78\x69\x74\x56\x61\x6c\x75\x65\x20\x5b").$exitValue)."\x5d"));if 
(($exitValue!=(0x14b5+ 2036-0x1ca9))){Logger::error ((((((
"\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x63\x72\x65\x61\x74\x65\x20\x61\x6c\x69\x61\x73\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x20"
.$interface)."\x20\x66\x6f\x72\x20\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x20").
$cmdOut)."\x20").$cmdErr));}saveInterfaceToFile ($interface);(my $return=
libnxhs::NXNetworkTakeoverIP ($GLOBAL::ClusterHost));Logger::debug (((((
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x4e\x65\x74\x77\x6f\x72\x6b\x54\x61\x6b\x65\x6f\x76\x65\x72\x49\x50\x28"
.$GLOBAL::ClusterHost)."\x29\x20\x5b").$return)."\x5d"));if (($return!=
(0x0532+ 1108-0x0986))){Logger::error (((
"\x4e\x65\x74\x77\x6f\x72\x6b\x20\x74\x61\x6b\x65\x6f\x76\x65\x72\x20\x66\x6f\x72\x20\x49\x50\x20"
.$GLOBAL::ClusterHost).
"\x20\x66\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x73\x74\x61\x72\x74\x2e"));}return
 ($exitValue);}sub NXClusterTools::cleanInterface{package NXClusterTools;no 
warnings;(my $interface=$GLOBAL::ClusterInterface);chomp ($interface);unless (
defined ($interface)){Logger::warning (
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x6c\x65\x61\x6e\x20\x63\x6c\x75\x73\x74\x65\x72\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x3a\x20\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x6e\x6f\x74\x20\x64\x65\x66\x69\x6e\x65\x64\x2e"
);return ((0x0647+ 323-0x0789));}(my (%interfaces)=getInterfaces ());if ((
$interfaces{$interface}eq (""))){Logger::debug (((
"\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x20".$interface).
"\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x63\x6c\x65\x61\x6e\x20\x75\x70\x2e"));(
$interface=__readInterfaceFromFile ());chomp ($interface);if (($interfaces{
$interface}eq (""))){Logger::debug (((
"\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x27".$interface).
"\x27\x20\x66\x72\x6f\x6d\x20\x66\x69\x6c\x65\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x63\x6c\x65\x61\x6e\x20\x75\x70\x2e"
));return ((0x1731+  17-0x1742));}}(my (@command)=());push (@command,
NXTools::getUnixCommandPath ("\x69\x66\x63\x6f\x6e\x66\x69\x67"));push (@command
,$interface);push (@command,"\x64\x6f\x77\x6e");(my (@options)=());sub BEGIN{
require NXTools;do{"\x4e\x58\x54\x6f\x6f\x6c\x73"->import};}(my ($cmdOut,$cmdErr
,$exitValue)=main::nxRunCommand ((\@command),(\@options)));Logger::debug (((((((
"\x63\x6d\x64\x4f\x75\x74\x20\x27".$cmdOut).
"\x27\x20\x63\x6d\x64\x45\x72\x72\x20\x27").$cmdErr).
"\x27\x20\x65\x78\x69\x74\x56\x61\x6c\x75\x65\x20\x27").$exitValue)."\x27\x2e"))
;if (($exitValue!=(0x0404+ 5893-0x1b09))){Logger::error (((((
"\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x64\x65\x6c\x65\x74\x65\x20\x61\x6c\x69\x61\x73\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x27"
.$interface).
"\x27\x2e\x20\x45\x78\x69\x74\x20\x76\x61\x6c\x75\x65\x20\x69\x73\x20\x27").
$exitValue)."\x27\x2e"));}return ($exitValue);}sub 
NXClusterTools::saveInterfaceToFile{package NXClusterTools;no warnings;(my $interface
=shift (@_));(my $filename=(((($GLOBAL::VAR_ROOT.$GLOBAL::DIRECTORY_SLASH).
"\x72\x75\x6e").$GLOBAL::DIRECTORY_SLASH).
"\x6e\x78\x63\x6c\x75\x73\x74\x65\x72\x2e\x69\x6e\x74\x65\x72\x66\x61\x63\x65"))
;(my $fileExisted=(0x029f+ 7563-0x202a));if (Common::NXFile::isExists ($filename
)){($fileExisted=(0x1969+ 730-0x1c42));}(my $FH=main::nxopen ($filename,(
$NXBits::O_RDWR+$NXBits::O_CREAT),(($NXBits::OthersRead+$NXBits::UserReadWrite)+
$NXBits::GroupRead)));if ((not (defined ($FH)))){(my $errorNumber=
libnxh::NXGetError ());(my $errorstring=libnxh::NXGetErrorString ());
Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x20".$filename
)."\x20\x66\x6f\x72\x20\x77\x72\x69\x74\x69\x6e\x67\x2e"));Logger::error (((((
"\x45\x72\x72\x6f\x72\x20\x69\x73\x20".$errorNumber)."\x2c\x20").$errorstring).
"\x2e"));return ((0x00b4+ 9732-0x26b7));}if ((main::nxwrite ($FH,($interface.
"\x0a"))==(-(0x1b27+ 2192-0x23b6)))){Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x77\x72\x69\x74\x65\x20\x74\x6f\x20\x66\x69\x6c\x65\x20\x27"
.$filename)."\x27\x2e"));main::nxclose ($FH);if ((not ($fileExisted))){
changeFileOwnershipToNxIfRoot ($filename);}return ((0x0d85+ 4371-0x1e97));}
main::nxclose ($FH);if ((not ($fileExisted))){changeFileOwnershipToNxIfRoot (
$filename);}return ((0x0aaf+ 4363-0x1bba));}sub 
NXClusterTools::__readInterfaceFromFile{package NXClusterTools;no warnings;(my $filename
=(((($GLOBAL::VAR_ROOT.$GLOBAL::DIRECTORY_SLASH)."\x72\x75\x6e").
$GLOBAL::DIRECTORY_SLASH).
"\x6e\x78\x63\x6c\x75\x73\x74\x65\x72\x2e\x69\x6e\x74\x65\x72\x66\x61\x63\x65"))
;if ((not (Common::NXFile::isExists ($filename)))){Logger::debug (((
"\x46\x69\x6c\x65\x20".$filename).
"\x20\x64\x6f\x65\x73\x20\x6e\x6f\x74\x20\x65\x78\x69\x73\x74\x2e"));return (
(0x13f3+ 3871-0x2311));}(my $FH=main::nxopen ($filename,$NXBits::O_RDONLY,
(0x16e8+ 3905-0x2629)));if ((not (defined ($FH)))){(my $errorNumber=
libnxh::NXGetError ());(my $errorstring=libnxh::NXGetErrorString ());
Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x20".$filename
)."\x20\x66\x6f\x72\x20\x72\x65\x61\x64\x69\x6e\x67\x2e"));Logger::error (((((
"\x45\x72\x72\x6f\x72\x20\x69\x73\x3a\x20".$errorNumber)."\x2c\x20").
$errorstring)."\x2e"));return ((0x14b5+ 4314-0x258f));}my ($interface);
main::nxreadLine ($FH,(\$interface));main::nxclose ($FH);return ($interface);}
sub NXClusterTools::getInterfaces{package NXClusterTools;no warnings;(my (
%interfaces)=());Logger::debug (
"\x6c\x69\x62\x6e\x78\x68\x3a\x3a\x4e\x58\x47\x65\x74\x4e\x65\x74\x77\x6f\x72\x6b\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x73"
);(my $return=libnxh::NXGetNetworkInterfaces ());Logger::debug (((
"\x6c\x69\x62\x6e\x78\x68\x3a\x3a\x4e\x58\x47\x65\x74\x4e\x65\x74\x77\x6f\x72\x6b\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x73\x20\x72\x65\x74\x75\x72\x6e\x73\x20\x27"
.$return)."\x27\x2e"));(my (@lines)=split ( /\n/ ,$return,(0x0571+ 4764-0x180d))
);foreach my $line (@lines){if (($line=~ /(^[\w:\d]+)\s+AF_INET\s+([0-9A-Fa-f]{2}[:-]){5}([0-9A-Fa-f]{2})+\s+(\d+\.\d+\.\d+\.\d+)\s+(\d+\.\d+\.\d+\.\d+)/ )
){Logger::debug ((((((("\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x27".$1).
"\x27\x2c\x20\x49\x50\x20\x27").$4)."\x27\x20\x6d\x61\x73\x6b\x20\x27").$5).
"\x27\x2e"));($interfaces{$1}={"\x69\x70",$4,"\x6d\x61\x73\x6b",$5});}}return (
%interfaces);}sub NXClusterTools::getClusterPublicKey{package NXClusterTools;no 
warnings;(my $file=NXPaths::getClusterRSAPublicKey ());if ((not (
Common::NXFile::isExists ($file)))){generateClusterKeys ();}(my $content=
Common::NXFile::getFileContent ($file));if (($content eq (""))){(my $message=(
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x3a\x20".$file));
Logger::error ($message);die ($message);}return ($content);}sub 
NXClusterTools::__setDatabaseBackup{package NXClusterTools;no warnings;(my $database
=shift (@_));(my $content=shift (@_));if (($content ne (""))){NXRedis::sendToDb 
(((((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x73\x65\x74\x6e\x78\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x62\x61\x63\x6b\x75\x70\x2e"
.$database)."\x2c\x76\x61\x6c\x75\x65\x3d").main::urlencode ($content))."\x0a"))
;}}sub NXClusterTools::getNodesDB{package NXClusterTools;no warnings;
main::nxrequire ("\x4e\x58\x4e\x6f\x64\x65\x73");return (
NXNodes::getDatabaseInString ());}sub NXClusterTools::getClusterDB{package 
NXClusterTools;no warnings;return (getDatabaseInString ());}sub 
NXClusterTools::getProfilesDB{package NXClusterTools;no warnings;main::nxrequire
 ("\x4e\x58\x50\x72\x6f\x66\x69\x6c\x65\x73\x44\x42");return (
NXProfilesDB::getDatabaseInString ());}sub NXClusterTools::getUsersDB{package 
NXClusterTools;no warnings;main::nxrequire (
"\x4e\x58\x55\x73\x65\x72\x73\x4d\x61\x6e\x61\x67\x65\x72");return (
NXUsersManager::getDatabaseInString ());}sub NXClusterTools::getAdministratorsDB
{package NXClusterTools;no warnings;main::nxrequire (
"\x4e\x58\x41\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x73\x4d\x61\x6e\x61\x67\x65\x72"
);return (NXAdministratorsManager::getDatabaseInString ());}sub 
NXClusterTools::getGroupsDB{package NXClusterTools;no warnings;main::nxrequire (
"\x4e\x58\x47\x72\x6f\x75\x70\x73");return (NXGroups::getDatabaseInString ());}
sub NXClusterTools::getNXCerts{package NXClusterTools;no warnings;
main::nxrequire ("\x4e\x58\x53\x65\x72\x76\x65\x72\x73");return (
NXServers::getNXCertsString ());}sub NXClusterTools::getSSHCerts{package 
NXClusterTools;no warnings;main::nxrequire (
"\x4e\x58\x53\x65\x72\x76\x65\x72\x73");return (NXServers::getSSHCertsString ())
;}sub NXClusterTools::getNetworkDB{package NXClusterTools;no warnings;return (
Common::NXFile::getFileContent (NXPaths::getNetworkDB ()));}sub 
NXClusterTools::getNetworkFile{package NXClusterTools;no warnings;return (
Common::NXFile::getFileContent (NXPaths::getNetworkFile ()));}sub 
NXClusterTools::getServerDSAPublicKey{package NXClusterTools;no warnings;(my $file
=NXPaths::getServerDSAPublicKey ());if ((not (Common::NXFile::isExists ($file)))
){return ((""));}return (Common::NXFile::getFileContent ($file));}sub 
NXClusterTools::getServerDSAPrivateKey{package NXClusterTools;no warnings;(my $file
=NXPaths::getServerDSAPrivateKey ());if ((not (Common::NXFile::isExists ($file))
)){return ((""));}return (Common::NXFile::getFileContent ($file));}sub 
NXClusterTools::getServerRSAPublicKey{package NXClusterTools;no warnings;(my $file
=NXPaths::getServerRSAPublicKey ());if ((not (Common::NXFile::isExists ($file)))
){return ((""));}return (Common::NXFile::getFileContent ($file));}sub 
NXClusterTools::getServerRSAPrivateKey{package NXClusterTools;no warnings;(my $file
=NXPaths::getServerRSAPrivateKey ());if ((not (Common::NXFile::isExists ($file))
)){return ((""));}return (Common::NXFile::getFileContent ($file));}sub 
NXClusterTools::getPlayerCerts{package NXClusterTools;no warnings;(my $file=
NXPaths::getUserNXKnownCerts ());(my $content=Common::NXFile::getFileContent (
$file));return ($content);}sub NXClusterTools::getHostPrivateCert{package 
NXClusterTools;no warnings;(my $file=NXPaths::getHostPrivateCert ());(my $content
=Common::NXFile::getFileContent ($file));if (($content eq (""))){(my $message=(
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x20\x66\x69\x6c\x65\x3a\x20"
.$file));Logger::error ($message);die ($message);}return (main::urlencode (
$content));}sub NXClusterTools::getHostPublicCert{package NXClusterTools;no 
warnings;(my $file=NXPaths::getHostPublicCert ());(my $content=
Common::NXFile::getFileContent ($file));if (($content eq (""))){(my $message=(
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x20\x66\x69\x6c\x65\x3a\x20"
.$file));Logger::error ($message);die ($message);}return ($content);}sub 
NXClusterTools::getClusterMasterCertPub{package NXClusterTools;no warnings;(my $file
=NXPaths::getClusterHostPublicCert ());if ((not (Common::NXFile::isExists ($file
)))){generateClusterHostCerts ();}(my $content=Common::NXFile::getFileContent (
$file));if (($content eq (""))){(my $message=(
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x20\x66\x69\x6c\x65\x3a\x20"
.$file));Logger::error ($message);die ($message);}return ($content);}sub 
NXClusterTools::getClusterMasterCertPriv{package NXClusterTools;no warnings;(my $file
=NXPaths::getClustetHostPrivateCert ());if ((not (Common::NXFile::isExists (
$file)))){generateClusterHostCerts ();}(my $content=
Common::NXFile::getFileContent ($file));if (($content eq (""))){(my $message=(
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x20\x66\x69\x6c\x65\x3a\x20"
.$file));Logger::error ($message);die ($message);}return ($content);}sub 
NXClusterTools::getSSHHostKeyDSAPrivate{package NXClusterTools;no warnings;(my $file
=NXPaths::getSSHHostKeyDSAPrivate ());(my $content=
Common::NXFile::getFileContent ($file));return ($content);}sub 
NXClusterTools::getSSHHostKeyDSAPublic{package NXClusterTools;no warnings;(my $file
=NXPaths::getSSHHostKeyDSAPublic ());(my $content=Common::NXFile::getFileContent
 ($file));return ($content);}sub NXClusterTools::getSSHHostKeyRSAPrivate{package
 NXClusterTools;no warnings;(my $file=NXPaths::getSSHHostKeyRSAPrivate ());(my $content
=Common::NXFile::getFileContent ($file));return ($content);}sub 
NXClusterTools::getSSHHostKeyRSAPublic{package NXClusterTools;no warnings;(my $file
=NXPaths::getSSHHostKeyRSAPublic ());(my $content=Common::NXFile::getFileContent
 ($file));return ($content);}sub NXClusterTools::getUserKnownHostsSSH{package 
NXClusterTools;no warnings;return (Common::NXFile::getFileContent (
NXPaths::getUserKnownHostsSSH ()));}sub NXClusterTools::__unsync{package 
NXClusterTools;no warnings;(my $file=shift (@_));(my $owner=shift (@_));(my $fileBackup
=($file."\x2e\x62\x61\x63\x6b\x75\x70"));if (Common::NXFile::isExists (
$fileBackup)){Logger::debug ((((("\x52\x65\x6e\x61\x6d\x65\x20\x27".$fileBackup)
."\x27\x20\x74\x6f\x20\x27").$file)."\x27\x2e"));unless (rename ($fileBackup,
$file)){Logger::error ((((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x6e\x61\x6d\x65\x20\x66\x69\x6c\x65\x20\x27"
.$fileBackup)."\x27\x20\x74\x6f\x20\x27").$file)."\x27\x2e\x20").$!));return (
(0x0792+ 1277-0x0c8e));}if (($owner ne "\x72\x6f\x6f\x74")){
changeFileOwnershipToNxIfRoot ($file);}}return ((0x0e03+ 6302-0x26a1));}sub 
NXClusterTools::__unsyncDatabases{package NXClusterTools;no warnings;if (
__isDatabaseBackupExist ("\x6e\x6f\x64\x65\x73")){main::nxrequire (
"\x4e\x58\x4e\x6f\x64\x65\x73");NXNodes::cleanDb ();NXNodes::setDatabaseByString
 (__getDatabaseBackup ("\x6e\x6f\x64\x65\x73"));}if (__isDatabaseBackupExist (
"\x70\x72\x6f\x66\x69\x6c\x65\x73")){main::nxrequire (
"\x4e\x58\x50\x72\x6f\x66\x69\x6c\x65\x73\x44\x42");NXProfilesDB::cleanDb ();
NXProfilesDB::setDatabaseByString (__getDatabaseBackup (
"\x70\x72\x6f\x66\x69\x6c\x65\x73"));}if (__isDatabaseBackupExist (
"\x75\x73\x65\x72\x73")){main::nxrequire (
"\x4e\x58\x55\x73\x65\x72\x73\x4d\x61\x6e\x61\x67\x65\x72");
NXUsersManager::cleanDb ();NXUsersManager::setDatabaseByString (
__getDatabaseBackup ("\x75\x73\x65\x72\x73"));}if (__isDatabaseBackupExist (
"\x61\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x73")){main::nxrequire (
"\x4e\x58\x41\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x73\x4d\x61\x6e\x61\x67\x65\x72"
);NXAdministratorsManager::cleanDb ();
NXAdministratorsManager::setDatabaseByString (__getDatabaseBackup (
"\x61\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x73"));}if (
__isDatabaseBackupExist ("\x63\x65\x72\x74\x73\x4e\x58")){main::nxrequire (
"\x4e\x58\x53\x65\x72\x76\x65\x72\x73");NXServers::setNXCertsByString (
__getDatabaseBackup ("\x63\x65\x72\x74\x73\x4e\x58"));}if (
__isDatabaseBackupExist ("\x63\x65\x72\x74\x73\x53\x53\x48")){main::nxrequire (
"\x4e\x58\x53\x65\x72\x76\x65\x72\x73");NXServers::setSSHCertsByString (
__getDatabaseBackup ("\x63\x65\x72\x74\x73\x53\x53\x48"));}if (
__isDatabaseBackupExist ("\x67\x72\x6f\x75\x70\x73")){main::nxrequire (
"\x4e\x58\x47\x72\x6f\x75\x70\x73");NXGroups::cleanDb ();
NXGroups::setDatabaseByString (__getDatabaseBackup ("\x67\x72\x6f\x75\x70\x73"))
;}}sub NXClusterTools::__isDatabaseBackupExist{package NXClusterTools;no 
warnings;(my $database=shift (@_));NXRedis::sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x65\x78\x69\x73\x74\x73\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x62\x61\x63\x6b\x75\x70\x2e"
.$database)."\x0a"));return (NXRedis::get ());}sub 
NXClusterTools::__getDatabaseBackup{package NXClusterTools;no warnings;(my $database
=shift (@_));NXRedis::sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x67\x65\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x62\x61\x63\x6b\x75\x70\x2e"
.$database)."\x0a"));return (main::urldecode (NXRedis::get ()));}sub 
NXClusterTools::__remove{package NXClusterTools;no warnings;(my $file=shift (@_)
);if (Common::NXFile::isExists ($file)){Logger::debug (((
"\x52\x65\x6d\x6f\x76\x69\x6e\x67\x20\x5b".$file)."\x5d"));if ((not (unlink (
$file)))){Logger::error ((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x6d\x6f\x76\x65\x20\x66\x69\x6c\x65\x20".
$file)."\x20").$!));}}}sub NXClusterTools::unsynchronize{package NXClusterTools;
no warnings;(my $host=shift (@_));__unsync (NXPaths::getUserNXKnownCerts ());
__unsync (NXPaths::getNXAuthorizedKeysPath ("\x6e\x78"));__unsync (
NXPaths::getNodePublicKeys ());if ((
Common::NXFile::setOwnerShipAndPermissionsReadOnlyForNX (
NXPaths::getNodePublicKeys ())==(-(0x064c+ 2296-0x0f43)))){Logger::error ((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x66\x69\x6c\x65\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x66\x6f\x72\x3a\x20"
.NXPaths::getNodePublicKeys ()));}__unsync (NXPaths::getUserKnownHostsSSH ());
__unsyncDatabases ();__remove (NXPaths::getClusterHostPublicCert ());__remove (
NXPaths::getClustetHostPrivateCert ());if (($host ne "\x6c\x6f\x63\x61\x6c")){
cleanDb ();}__unsync (NXPaths::getNetworkFile ());__unsync (
NXPaths::getNetworkDB ());}sub NXClusterTools::cleanSSHKeys{package 
NXClusterTools;no warnings;__unsync (NXPaths::getSSHHostKeyDSAPrivate (),
"\x72\x6f\x6f\x74");__unsync (NXPaths::getSSHHostKeyDSAPublic (),
"\x72\x6f\x6f\x74");__unsync (NXPaths::getSSHHostKeyRSAPrivate (),
"\x72\x6f\x6f\x74");__unsync (NXPaths::getSSHHostKeyRSAPublic (),
"\x72\x6f\x6f\x74");}sub NXClusterTools::addClusterKey{package NXClusterTools;no
 warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getNXAuthorizedKeysPath ("\x6e\x78"));(my $rights=
$NXBits::UserReadWrite);return (__appendFile ($file,$rights,$fileContent,
(0x1574+ 4706-0x2656)));}sub NXClusterTools::setNodesDB{package NXClusterTools;
no warnings;(my $fileContent=shift (@_));main::nxrequire (
"\x4e\x58\x4e\x6f\x64\x65\x73");__setDatabaseBackup ("\x6e\x6f\x64\x65\x73",
NXNodes::getDatabaseInString ());NXNodes::cleanDb ();return (
NXNodes::setDatabaseByString ($fileContent));}sub NXClusterTools::setClusterDB{
package NXClusterTools;no warnings;(my $fileContent=shift (@_));cleanDb ();
return (setDatabaseByString ($fileContent));}sub NXClusterTools::setProfilesDB{
package NXClusterTools;no warnings;(my $fileContent=shift (@_));main::nxrequire 
("\x4e\x58\x50\x72\x6f\x66\x69\x6c\x65\x73\x44\x42");__setDatabaseBackup (
"\x70\x72\x6f\x66\x69\x6c\x65\x73",NXProfilesDB::getDatabaseInString ());
NXProfilesDB::cleanDb ();return (NXProfilesDB::setDatabaseByString ($fileContent
));}sub NXClusterTools::setUsersDB{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));main::nxrequire (
"\x4e\x58\x55\x73\x65\x72\x73\x4d\x61\x6e\x61\x67\x65\x72");__setDatabaseBackup 
("\x75\x73\x65\x72\x73",NXUsersManager::getDatabaseInString ());
NXUsersManager::cleanDb ();return (NXUsersManager::setDatabaseByString (
$fileContent));}sub NXClusterTools::setAdministratorsDB{package NXClusterTools;
no warnings;(my $fileContent=shift (@_));main::nxrequire (
"\x4e\x58\x41\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x73\x4d\x61\x6e\x61\x67\x65\x72"
);__setDatabaseBackup (
"\x61\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x73",
NXAdministratorsManager::getDatabaseInString ());
NXAdministratorsManager::cleanDb ();return (
NXAdministratorsManager::setDatabaseByString ($fileContent));}sub 
NXClusterTools::setGroupsDB{package NXClusterTools;no warnings;(my $fileContent=
shift (@_));main::nxrequire ("\x4e\x58\x47\x72\x6f\x75\x70\x73");
__setDatabaseBackup ("\x67\x72\x6f\x75\x70\x73",NXGroups::getDatabaseInString ()
);NXGroups::cleanDb ();return (NXGroups::setDatabaseByString ($fileContent));}
sub NXClusterTools::setNXCertsDB{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));main::nxrequire ("\x4e\x58\x53\x65\x72\x76\x65\x72\x73");
__setDatabaseBackup ("\x63\x65\x72\x74\x73\x4e\x58",NXServers::getNXCertsString 
());return (NXServers::setNXCertsByString ($fileContent));}sub 
NXClusterTools::setSSHCertsDB{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));main::nxrequire ("\x4e\x58\x53\x65\x72\x76\x65\x72\x73");
__setDatabaseBackup ("\x63\x65\x72\x74\x73\x53\x53\x48",
NXServers::getSSHCertsString ());return (NXServers::setSSHCertsByString (
$fileContent));}sub NXClusterTools::setNetworkDB{package NXClusterTools;no 
warnings;(my $fileContent=shift (@_));(my $file=NXPaths::getNetworkDB ());(my $rights
=$NXBits::UserReadWrite);return (__setFile ($file,$rights,$fileContent,
(0x0e36+ 2108-0x14f2)));}sub NXClusterTools::setNetworkFile{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getNetworkFile ());(my $rights=(($NXBits::UserReadWrite+
$NXBits::GroupRead)+$NXBits::OthersRead));return (__setFile ($file,$rights,
$fileContent,(0x0537+ 7591-0x213a)));}sub NXClusterTools::setServerDSAPublicKey{
package NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getServerDSAPublicKey ());(my $rights=(($NXBits::UserReadWrite+
$NXBits::GroupRead)+$NXBits::OthersRead));return (__setFile ($file,$rights,
$fileContent,(0x038c+ 650-0x0472)));}sub NXClusterTools::setServerDSAPrivateKey{
package NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getServerDSAPrivateKey ());(my $rights=$NXBits::UserReadWrite);return (
__setFile ($file,$rights,$fileContent,(0x0bad+ 6140-0x2229)));}sub 
NXClusterTools::setServerRSAPublicKey{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getServerRSAPublicKey ());(my $rights=((
$NXBits::UserReadWrite+$NXBits::GroupRead)+$NXBits::OthersRead));return (
__setFile ($file,$rights,$fileContent,(0x1350+ 2864-0x1cdc)));}sub 
NXClusterTools::setServerRSAPrivateKey{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getServerRSAPrivateKey ());(my $rights=
$NXBits::UserReadWrite);return (__setFile ($file,$rights,$fileContent,
(0x0850+ 6501-0x2035)));}sub NXClusterTools::setClientCerts{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getUserNXKnownCerts ());(my $rights=$NXBits::UserReadWrite);return (
__setFile ($file,$rights,$fileContent,(0x13cd+ 3582-0x204b)));}sub 
NXClusterTools::setAuthorizedCerts{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getNXAuthorizedKeysPath ("\x6e\x78"));(my $rights
=$NXBits::UserReadWrite);return (__setFile ($file,$rights,$fileContent,
(0x04c0+ 3699-0x11b3)));}sub NXClusterTools::setSSHAuthorizedCerts{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getNodePublicKeys ());(my $rights=$NXBits::UserReadWrite);return (
__setFile ($file,$rights,$fileContent,(0x176f+ 1524-0x1be3)));}sub 
NXClusterTools::addSSHAuthorizedCerts{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getNodePublicKeys ());if (
Common::NXFile::isExists ($file)){my ($error);if ((
Common::NXFile::setPermissionsReadWriteForNX ($file,(\$error))==(-
(0x0157+ 1206-0x060c)))){Logger::error (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x68\x61\x6e\x67\x65\x20\x72\x69\x67\x68\x74\x73\x20\x74\x6f\x20\x27"
.$file)."\x27\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20\x27").$error).
"\x27\x2e"));return ((0x0a03+ 6254-0x2270));}}(my $rights=$NXBits::UserReadWrite
);return (__appendFile ($file,$rights,$fileContent,(0x0a65+ 6184-0x210d)));}sub 
NXClusterTools::__setHostPrivateCert{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getHostPrivateCert ());(my $rights=
$NXBits::UserReadWrite);return (__setFile ($file,$rights,$fileContent,
(0x0b2f+ 4096-0x19af)));}sub NXClusterTools::__setHostPublicCert{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getHostPublicCert ());(my $rights=$NXBits::UserReadWrite);return (
__setFile ($file,$rights,$fileContent,(0x12a6+ 936-0x14ce)));}sub 
NXClusterTools::setClusterMasterCertPub{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getClusterHostPublicCert ());(my $rights=
$NXBits::UserReadWrite);return (__setFile ($file,$rights,$fileContent,
(0x1edf+ 1020-0x215b)));}sub NXClusterTools::setClusterMasterCertPriv{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getClustetHostPrivateCert ());(my $rights=$NXBits::UserReadWrite);
return (__setFile ($file,$rights,$fileContent,(0x0dd7+ 4691-0x1eaa)));}sub 
NXClusterTools::setKnownHostsSSH{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getUserKnownHostsSSH ());(my $rights=
$NXBits::UserReadWrite);return (__setFile ($file,$rights,$fileContent,
(0x022a+ 4035-0x106d)));}sub NXClusterTools::setSSHHostKeyDSAPrivate{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getSSHHostKeyDSAPrivate ());(my $rights=$NXBits::UserReadWrite);
__setFile ($file,$rights,$fileContent,(0x13ab+ 692-0x14df),"\x72\x6f\x6f\x74");
return ((0x0527+ 2074-0x0d41));}sub NXClusterTools::setSSHHostKeyDSAPublic{
package NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getSSHHostKeyDSAPublic ());(my $rights=(($NXBits::UserReadWrite+
$NXBits::GroupRead)+$NXBits::OthersRead));__setFile ($file,$rights,$fileContent,
(0x0968+ 1455-0x0d73),"\x72\x6f\x6f\x74");return ((0x0146+ 4643-0x1369));}sub 
NXClusterTools::setSSHHostKeyRSAPrivate{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getSSHHostKeyRSAPrivate ());(my $rights=
$NXBits::UserReadWrite);__setFile ($file,$rights,$fileContent,
(0x01b4+ 1984-0x07f4),"\x72\x6f\x6f\x74");return ((0x0657+ 5155-0x1a7a));}sub 
NXClusterTools::setSSHHostKeyRSAPublic{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getSSHHostKeyRSAPublic ());(my $rights=((
$NXBits::UserReadWrite+$NXBits::GroupRead)+$NXBits::OthersRead));__setFile (
$file,$rights,$fileContent,(0x0255+ 687-0x0360),"\x72\x6f\x6f\x74");return (
(0x118a+ 4279-0x2241));}sub NXClusterTools::__backupPrevious{package 
NXClusterTools;no warnings;(my $original=shift (@_));(my $rights=shift (@_));(my $owner
=shift (@_));unless (Common::NXFile::fileExists ($original)){return (
(0x0507+ 4122-0x1521));}(my $backup=($original."\x2e\x62\x61\x63\x6b\x75\x70"));
if (Common::NXFile::fileExists ($backup)){($backup.=("\x2d".NXTools::getTimeMs 
()));}(my ($retValue,$outMsg)=Common::NXCore::copyFile ($original,$backup));if (
($outMsg ne (""))){Logger::error (((((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x6f\x70\x79\x20\x27".$original).
"\x27\x20\x74\x6f\x20\x27").$backup).
"\x27\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20\x27").$outMsg)."\x27\x2e"));
return ((0x04a6+ 6749-0x1f02));}my ($error);if ((Common::NXFile::setPermission (
$backup,$rights,(\$error))==(-(0x0a3a+ 4619-0x1c44)))){Logger::warning (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x68\x61\x6e\x67\x65\x20\x72\x69\x67\x68\x74\x73\x20\x74\x6f\x20"
.$backup)."\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20\x27").$error)."\x27\x2e"
));return ((0x0729+ 4538-0x18e2));}unless (Common::NXFile::fileExists ($backup))
{Logger::error (((((
"\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x63\x72\x65\x61\x74\x65\x20\x66\x69\x6c\x65\x20\x62\x61\x63\x6b\x75\x70\x20\x27"
.$backup)."\x27\x20\x66\x6f\x72\x20\x27").$original)."\x27\x2e"));return (
(0x012a+ 5174-0x155f));}if (($owner ne "\x72\x6f\x6f\x74")){
changeFileOwnershipToNxIfRoot ($backup);}return ((0x1c51+ 1422-0x21df));}sub 
NXClusterTools::__setFile{package NXClusterTools;no warnings;(my $file=shift (@_
));(my $rights=shift (@_));(my $fileBody=shift (@_));(my $backupRights=shift (@_
));(my $backupOwner=shift (@_));if (__backupPrevious ($file,$backupRights,
$backupOwner)){return ((0x0993+ 4070-0x1978));}(my $fileBackup=($file.
"\x2e\x74\x6d\x70"));(my $fileDesc=main::nxopen ($fileBackup,($NXBits::O_WRONLY+
$NXBits::O_CREAT),$rights));unless (defined ($fileDesc)){Logger::error (((
"\x45\x72\x72\x6f\x72\x20\x6f\x70\x65\x6e\x69\x6e\x67\x20\x66\x69\x6c\x65\x20\x27"
.$fileBackup)."\x27\x2e"));return ((0x0326+ 716-0x05f1));}if ((main::nxwrite (
$fileDesc,$fileBody)==(-(0x0ae0+ 1538-0x10e1)))){(my $errorNumber=
libnxh::NXGetError ());(my $errorstring=libnxh::NXGetErrorString ());
Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x77\x72\x69\x74\x65\x20\x74\x6f\x20\x66\x69\x6c\x65\x20\x27"
.$fileBackup)."\x27\x2e"));Logger::error (((((
"\x45\x72\x72\x6f\x72\x20\x69\x73\x3a\x20".$errorNumber)."\x2c\x20").
$errorstring)."\x2e"));main::nxclose ($fileDesc);if (($backupOwner ne 
"\x72\x6f\x6f\x74")){changeFileOwnershipToNxIfRoot ($fileBackup);}return (
(0x07af+ 5499-0x1d29));}main::nxclose ($fileDesc);if (($backupOwner ne 
"\x72\x6f\x6f\x74")){changeFileOwnershipToNxIfRoot ($fileBackup);}unless (rename
 ($fileBackup,$file)){Logger::error (((((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x6e\x61\x6d\x65\x20\x66\x69\x6c\x65\x20\x27"
.$fileBackup)."\x27\x20\x74\x6f\x20\x27").$file).
"\x27\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20\x27").$!)."\x27\x2e"));return 
((0x1201+ 1195-0x16ab));}return ((0x035a+ 1867-0x0aa5));}sub 
NXClusterTools::__appendFile{package NXClusterTools;no warnings;(my $file=shift 
(@_));(my $rights=shift (@_));(my $fileBody=shift (@_));(my $rightBackup=shift (
@_));(my $ownerBackup=shift (@_));if (__backupPrevious ($file,$rightBackup,
$ownerBackup)){return ((0x21e9+ 805-0x250d));}(my $fileExisted=
(0x0637+ 601-0x0890));if (Common::NXFile::isExists ($file)){($fileExisted=
(0x2052+  39-0x2078));}(my $fileDesc=main::nxopen ($file,(($NXBits::O_WRONLY+
$NXBits::O_CREAT)+$NXBits::O_APPEND),$rights));unless (defined ($fileDesc)){
Logger::error (((
"\x45\x72\x72\x6f\x72\x20\x77\x68\x69\x6c\x65\x20\x6f\x70\x65\x6e\x69\x6e\x67\x20\x66\x69\x6c\x65\x20\x27"
.$file)."\x27\x20\x74\x6f\x20\x61\x70\x70\x65\x6e\x64\x2e"));return (
(0x01b3+ 4430-0x1300));}if ((main::nxwrite ($fileDesc,$fileBody)==(-
(0x0069+ 9149-0x2425)))){(my $errorNumber=libnxh::NXGetError ());(my $errorstring
=libnxh::NXGetErrorString ());Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x77\x72\x69\x74\x65\x20\x74\x6f\x20\x66\x69\x6c\x65\x20"
.$file)."\x2e"));Logger::error ((((("\x45\x72\x72\x6f\x72\x20\x69\x73\x3a\x20".
$errorNumber)."\x2c\x20").$errorstring)."\x2e"));main::nxclose ($fileDesc);if ((
not ($fileExisted))){if (($ownerBackup ne "\x72\x6f\x6f\x74")){
changeFileOwnershipToNxIfRoot ($file);}}return ((0x1daf+ 2200-0x2646));}
main::nxclose ($fileDesc);if ((not ($fileExisted))){
changeFileOwnershipToNxIfRoot ($file);}return ((0x0f67+  15-0x0f76));}sub 
NXClusterTools::__addClusterNodeKey{package NXClusterTools;no warnings;(my $message
=shift (@_));($message=main::urldecode ($message));return (addClusterKey (
$message));}sub NXClusterTools::checkUserNXConfigDir{package NXClusterTools;no 
warnings;(my $path=NXPaths::getConfigDir ());unless (Common::NXFile::isExists (
$path)){my ($error);unless (Common::NXPaths::createAccessibleForNXDirectory ((
\$error),$path)){return ((0x1253+ 4022-0x2209));}}return ((0x0086+ 5693-0x16c2))
;}sub NXClusterTools::isItMyIP{package NXClusterTools;no warnings;(my $IPtoCheck
=shift (@_));Logger::debug (((
"\x43\x68\x65\x63\x6b\x20\x69\x73\x20\x6d\x79\x20\x49\x50\x20\x5b".$IPtoCheck).
"\x5d"));if ((not (defined ($IPtoCheck)))){return ((0x065d+ 4708-0x18c1));}(my (
%interfaces)=getInterfaces ());foreach my $name (keys (%interfaces)){
Logger::debug ((((("\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x5b".$name).
"\x5d\x20\x69\x70\x20\x5b").$interfaces{$name}{"\x69\x70"})."\x5d"));if ((
$interfaces{$name}{"\x69\x70"}eq $IPtoCheck)){return ((0x0361+ 5321-0x1829));}}
return ((0x0061+ 4562-0x1233));}sub NXClusterTools::prepareNXKnownCerts{package 
NXClusterTools;no warnings;(my $refClusterHash=shift (@_));my ($file);foreach my $key
 (keys (%$refClusterHash)){(my $value=$$refClusterHash{$key});chomp ($value);if 
(Common::NXShellCreate::isHostInCertFile ($key,NXPaths::getCurrentUserKnownCerts
 ())){Common::NXShellCreate::removeCertificate ($key,$value,
NXPaths::getUserNXKnownCerts ());}($file.=(((("\x48\x6f\x73\x74\x3a".$key).
"\x0a").$value)."\x0a"));}(my $myIp=$GLOBAL::ClusterOldLocal);(my $myCert=
getHostPublicCert ());chomp ($myCert);if (
Common::NXShellCreate::isHostInCertFile ($myIp,NXPaths::getCurrentUserKnownCerts
 ())){Common::NXShellCreate::removeCertificate ($myIp,$myCert,
NXPaths::getUserNXKnownCerts ());}($file.=(((("\x48\x6f\x73\x74\x3a".$myIp).
"\x0a").$myCert)."\x0a"));(my $hostCert=getClusterMasterCertPub ());chomp (
$hostCert);if (Common::NXShellCreate::isHostInCertFile ($GLOBAL::ClusterHost,
NXPaths::getCurrentUserKnownCerts ())){Common::NXShellCreate::removeCertificate 
($GLOBAL::ClusterHost,$hostCert,NXPaths::getUserNXKnownCerts ());}($file.=((((
"\x48\x6f\x73\x74\x3a".$GLOBAL::ClusterHost)."\x0a").$hostCert)."\x0a"));($file
.=getPlayerCerts ());setClientCerts ($file);(my $path=
NXPaths::getUserNXKnownCerts ());changeFileOwnershipToNxIfRoot ($path);return (
$file);}sub NXClusterTools::__preparePublicKeys{package NXClusterTools;no 
warnings;(my $ref_publicKeys=shift (@_));(my $protocol=shift (@_));(my $file=
(""));my ($filePath);if (($protocol eq "\x53\x53\x48")){($filePath=
NXPaths::getNodePublicKeys ());}else{($filePath=NXPaths::getNXAuthorizedKeysPath
 ("\x6e\x78"));}(my $fileContent=Common::NXFile::getFileContent ($filePath));(my (
@oldContent)=split ( /\n/ ,$fileContent,(0x260f+ 141-0x269c)));(my $prefix=
"\x6e\x6f\x2d\x70\x6f\x72\x74\x2d\x66\x6f\x72\x77\x61\x72\x64\x69\x6e\x67\x2c\x6e\x6f\x2d\x61\x67\x65\x6e\x74\x2d\x66\x6f\x72\x77\x61\x72\x64\x69\x6e\x67\x2c"
);($prefix.=(("\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x22".$GLOBAL::ETC_DIR).
$GLOBAL::DIRECTORY_SLASH));($prefix.=
"\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x72\x65\x6d\x6f\x74\x65\x6c\x6f\x67\x69\x6e\x22\x20"
);foreach my $key (keys (%$ref_publicKeys)){(my $potentialKey=$$ref_publicKeys{
$key});(my $add=(0x0548+ 6265-0x1dc0));chomp ($potentialKey);($potentialKey=~ s/\r//g )
;if (($protocol eq "\x53\x53\x48")){($potentialKey=($prefix.$potentialKey));}
foreach my $line (@oldContent){chomp ($line);($line=~ s/\r//g );if ((
$potentialKey eq $line)){($add=(0x0e93+ 2933-0x1a08));last;}}if (($add==
(0x0ce5+ 6479-0x2633))){($file.=($potentialKey."\x0a"));}}(my $potentialKey=
getClusterPublicKey ());chomp ($potentialKey);($potentialKey=~ s/\r//g );if ((
$protocol eq "\x53\x53\x48")){($potentialKey=($prefix.$potentialKey));}(my $add=
(0x0dc0+ 1459-0x1372));foreach my $line (@oldContent){chomp ($line);($line=~ s/\r//g )
;if (($potentialKey eq $line)){($add=(0x0829+ 7342-0x24d7));last;}}if (($add==
(0x06d5+ 5816-0x1d8c))){($file.=($potentialKey."\x0a"));}($file.=$fileContent);
if (($protocol eq "\x53\x53\x48")){setSSHAuthorizedCerts ($file);}else{
setAuthorizedCerts ($file);}return ($file);}sub 
NXClusterTools::prepareNXDPublicKeys{package NXClusterTools;no warnings;(my $ref_publicKeys
=shift (@_));return (__preparePublicKeys ($ref_publicKeys,"\x4e\x58"));}sub 
NXClusterTools::prepareSSHPublicKeys{package NXClusterTools;no warnings;(my $ref_publicKeys
=shift (@_));return (__preparePublicKeys ($ref_publicKeys,"\x53\x53\x48"));}sub 
NXClusterTools::prepareSSHClusterKey{package NXClusterTools;no warnings;(my $prefix
=
"\x6e\x6f\x2d\x70\x6f\x72\x74\x2d\x66\x6f\x72\x77\x61\x72\x64\x69\x6e\x67\x2c\x6e\x6f\x2d\x61\x67\x65\x6e\x74\x2d\x66\x6f\x72\x77\x61\x72\x64\x69\x6e\x67\x2c"
);($prefix.=((("\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x22".$GLOBAL::ETC_DIR).
$GLOBAL::DIRECTORY_SLASH).
"\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x72\x65\x6d\x6f\x74\x65\x6c\x6f\x67\x69\x6e\x22\x20"
));(my $key=($prefix.getClusterPublicKey ()));return ($key);}sub 
NXClusterTools::prepareKnownHostsSSH{package NXClusterTools;no warnings;(my $host
=shift (@_));(my $sshCrt=shift (@_));($sshCrt=~ s/\015//gs );my ($file);if ((
$sshCrt ne (""))){($file=(((($GLOBAL::ClusterPool."\x2c").$GLOBAL::ClusterHost).
"\x20").$sshCrt));}Common::NXShellCreate::removeCertificateSSH (
$GLOBAL::ClusterHost,(""),NXPaths::getUserKnownHostsSSH ());(my (@hosts)=split ( /,/ ,
$GLOBAL::ClusterPool,(0x0d14+ 5210-0x216e)));foreach my $host (@hosts){
Common::NXShellCreate::removeCertificateSSH ($host,(""),
NXPaths::getUserKnownHostsSSH ());}($file.=getUserKnownHostsSSH ());
setKnownHostsSSH ($file);return ($file);}sub NXClusterTools::checkKeys{package 
NXClusterTools;no warnings;if ((not (Common::NXFile::isExists (
NXPaths::getClusterRSAPrivateKey ())))){generateClusterKeys ();}if ((not (
Common::NXFile::isExists (NXPaths::getClusterRSAPublicKey ())))){
generateClusterKeys ();}if ((not (Common::NXFile::isExists (
NXPaths::getClusterHostPublicCert ())))){generateClusterHostCerts ();}if ((not (
Common::NXFile::isExists (NXPaths::getClustetHostPrivateCert ())))){
generateClusterHostCerts ();}}sub NXClusterTools::changeFileOwnershipToNxIfRoot{
package NXClusterTools;no warnings;(my $file=shift (@_));(my $user=
Common::NXCore::getEffectiveUsername ());if (($user eq "\x72\x6f\x6f\x74")){
Logger::debug2 (((
"\x53\x65\x74\x74\x69\x6e\x67\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x66\x6f\x72\x20\x75\x73\x65\x72\x20\x6e\x78\x2c\x20"
.$file)."\x2e"));my ($errorName);my ($errorCode);if ((
Common::NXFile::setOwnershipForUserSilent ($file,"\x6e\x78",(\$errorName),(
\$errorCode))==(-(0x0298+ 7593-0x2040)))){Logger::error ((((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x66\x69\x6c\x65\x20"
.$file)."\x2e\x20").$errorCode)."\x20").$errorName));NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x53\x65\x74\x4f\x77\x6e\x65\x72\x73\x68\x69\x70",
"\x4e\x58\x53\x68\x65\x6c\x6c",(($file."\x2e\x20").$errorName));unlink ($file);
main::nxexit ((0x0a48+ 111-0x0ab7));}}return ((0x02b1+ 4466-0x1423));}sub 
NXClusterTools::__getPathToPublicKey{package NXClusterTools;no warnings;if (
__isRSAKeyAvailable ()){return (NXPaths::getClusterRSAPrivateKey ());}return (
NXPaths::getClusterDSAPrivateKey ());}sub NXClusterTools::getDatabaseInString{
package NXClusterTools;no warnings;(my $request=
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x68\x6d\x67\x65\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2e\x63\x6f\x6e\x66\x69\x67\x2c\x66\x69\x65\x6c\x64\x3d\x6d\x61\x73\x74\x65\x72\x2c\x66\x69\x65\x6c\x64\x3d\x73\x68\x61\x72\x65\x64\x2c\x66\x69\x65\x6c\x64\x3d\x70\x72\x6f\x74\x6f\x2c\x66\x69\x65\x6c\x64\x3d\x67\x72\x61\x63\x65"
);($request.=
"\x2c\x66\x69\x65\x6c\x64\x3d\x72\x65\x74\x72\x79\x2c\x66\x69\x65\x6c\x64\x3d\x70\x72\x6f\x62\x65\x2c\x66\x69\x65\x6c\x64\x3d\x69\x6e\x74\x65\x72\x76\x61\x6c\x2c\x66\x69\x65\x6c\x64\x3d\x74\x69\x6d\x65\x6f\x75\x74\x2c\x66\x69\x65\x6c\x64\x3d\x6d\x61\x69\x6e\x43\x6c\x75\x73\x74\x65\x72\x55\x55\x49\x44\x2c\x66\x69\x65\x6c\x64\x3d\x63\x6c\x75\x73\x74\x65\x72\x47\x55\x49\x44\x0a"
);(my $databaseString=(""));NXRedis::sendToDb ($request);(my $config=
NXRedis::get ());($config=~ s/ /,/g );($databaseString.=($config."\x0a"));
NXRedis::sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x73\x6d\x65\x6d\x62\x65\x72\x73\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x0a"
);(my $clusterList=NXRedis::get ());(my (@list)=split ( / / ,$clusterList,
(0x0912+ 349-0x0a6f)));foreach $host (@list){NXRedis::sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x68\x6d\x67\x65\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2e"
.$host).
"\x2c\x66\x69\x65\x6c\x64\x3d\x68\x6f\x73\x74\x2c\x66\x69\x65\x6c\x64\x3d\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x2c\x66\x69\x65\x6c\x64\x3d\x6e\x65\x74\x6d\x61\x73\x6b\x0a"
));(my $line=NXRedis::get ());($line=~ s/ /,/g );($databaseString.=($line."\x0a"
));}return ($databaseString);}sub NXClusterTools::setDatabaseByString{package 
NXClusterTools;no warnings;(my $string=shift (@_));(my (@clusterList)=split ( /\n/ ,
$string,(0x0181+ 3265-0x0e42)));(my $redisString=__setConfigLine ($clusterList[
(0x058d+ 6050-0x1d2f)]));NXRedis::sendToDb ($redisString);(my ($host1data,
$host1set)=__setHostLineS ($clusterList[(0x0b99+ 4794-0x1e52)]));
NXRedis::sendToDb ($host1data);NXRedis::sendToDb ($host1set);(my ($host2data,
$host2set)=__setHostLineS ($clusterList[(0x0e1a+ 4865-0x2119)]));
NXRedis::sendToDb ($host2data);NXRedis::sendToDb ($host2set);return (
(0x055f+ 1899-0x0cca));}sub NXClusterTools::__setConfigLine{package 
NXClusterTools;no warnings;(my $configLine=shift (@_));(my $record=
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x68\x6d\x73\x65\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2e\x63\x6f\x6e\x66\x69\x67"
);(my (@options)=split ( /,/ ,$configLine,(0x19bd+ 1261-0x1eaa)));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x6d\x61\x73\x74\x65\x72\x2c\x76\x61\x6c\x75\x65\x3d"
.$options[(0x00aa+ 4185-0x1103)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x73\x68\x61\x72\x65\x64\x2c\x76\x61\x6c\x75\x65\x3d"
.$options[(0x1364+ 483-0x1546)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x70\x72\x6f\x74\x6f\x2c\x76\x61\x6c\x75\x65\x3d".
$options[(0x0d19+ 943-0x10c6)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x67\x72\x61\x63\x65\x2c\x76\x61\x6c\x75\x65\x3d".
$options[(0x05ca+ 4993-0x1948)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x72\x65\x74\x72\x79\x2c\x76\x61\x6c\x75\x65\x3d".
$options[(0x00bb+ 4239-0x1146)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x70\x72\x6f\x62\x65\x2c\x76\x61\x6c\x75\x65\x3d".
$options[(0x0456+ 3546-0x122b)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x69\x6e\x74\x65\x72\x76\x61\x6c\x2c\x76\x61\x6c\x75\x65\x3d"
.$options[(0x0305+ 731-0x05da)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x74\x69\x6d\x65\x6f\x75\x74\x2c\x76\x61\x6c\x75\x65\x3d"
.$options[(0x007d+ 6704-0x1aa6)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x6d\x61\x69\x6e\x43\x6c\x75\x73\x74\x65\x72\x55\x55\x49\x44\x2c\x76\x61\x6c\x75\x65\x3d"
.$options[(0x00c2+ 3797-0x0f8f)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x63\x6c\x75\x73\x74\x65\x72\x47\x55\x49\x44\x2c\x76\x61\x6c\x75\x65\x3d"
.$options[(0x09e5+ 5612-0x1fc8)]));($record.="\x0a");return ($record);}sub 
NXClusterTools::__setHostLineS{package NXClusterTools;no warnings;(my $hostLine=
shift (@_));(my (@host)=split ( /,/ ,$hostLine,(0x105d+ 3296-0x1d3d)));(my $record
=(
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x68\x6d\x73\x65\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2e"
.$host[(0x01a9+ 4691-0x13fc)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x68\x6f\x73\x74\x2c\x76\x61\x6c\x75\x65\x3d".$host
[(0x08a0+ 7162-0x249a)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x2c\x76\x61\x6c\x75\x65\x3d"
.$host[(0x14db+ 606-0x1738)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x6e\x65\x74\x6d\x61\x73\x6b\x2c\x76\x61\x6c\x75\x65\x3d"
.$host[(0x09fd+ 4667-0x1c36)]));($record.="\x0a");(my $setRecord=((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x73\x61\x64\x64\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2c\x66\x69\x65\x6c\x64\x3d"
.$host[(0x0108+ 2379-0x0a53)])."\x0a"));return ($record,$setRecord);}sub 
NXClusterTools::cleanDb{package NXClusterTools;no warnings;NXRedis::sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x73\x6d\x65\x6d\x62\x65\x72\x73\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x0a"
);(my (@hosts)=split ( / / ,NXRedis::get (),(0x22d6+ 844-0x2622)));
NXRedis::sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x64\x65\x6c\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x0a"
);foreach my $host (@hosts){NXRedis::sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x64\x65\x6c\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2e"
.$host)."\x0a"));}NXRedis::sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x64\x65\x6c\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2e\x63\x6f\x6e\x66\x69\x67\x0a"
);return ((0x09f8+ 2157-0x1265));}package NXClusterTools;no warnings;return (
(0x0b15+ 524-0x0d20));
